Merge "Add support for odl-fdio scenario"
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
18     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
19       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
20     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
21       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
22       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
23         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
24       fi
25     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
26       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
27     else
28       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
29     fi
30     SDN_IMAGE=opendaylight
31   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
32     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
33     SDN_IMAGE=opendaylight
34   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
35     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
36       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
37     else
38       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
39     fi
40     SDN_IMAGE=onos
41   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
42     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
43     exit 1
44   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
45     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
46     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
47       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
48     fi
49     SDN_IMAGE=opendaylight
50   else
51     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
52     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
53     exit 1
54   fi
55
56   # Enable Tacker
57   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
58     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
59   fi
60
61   # Make sure the correct overcloud image is available
62   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
63       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
64       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
65       exit 1
66   fi
67
68   echo "Copying overcloud image to Undercloud"
69   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
70   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
71
72   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
73       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
74       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
75       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
76                                                --run-command "systemctl enable zrpcd" \
77                                                -a overcloud-full.qcow2
78 EOI
79   fi
80
81   # Install ovs-dpdk inside the overcloud image if it is enabled.
82   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
83     # install dpdk packages before ovs
84     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
85
86     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
87       cat << EOF > vfio_pci.modules
88 #!/bin/bash
89 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
90 EOF
91
92       cat << EOF > uio_pci_generic.modules
93 #!/bin/bash
94 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
95 EOF
96
97       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
98                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
99                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
100                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
101                                                -a overcloud-full.qcow2
102
103       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
104         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
105                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
106                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
107                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
108                                                  -a overcloud-full.qcow2
109       fi
110
111 EOI
112
113   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
114     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
115     exit 1
116   fi
117
118   if [ "$debug" == 'TRUE' ]; then
119     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
120   fi
121
122   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
123   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
124     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
125          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
126                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
127                                                   -a overcloud-full.qcow2
128 EOI
129   fi
130
131   if [ -n "${deploy_options_array['performance']}" ]; then
132     for option in "${performance_options[@]}" ; do
133     arr=($option)
134     # use compute's kernel settings for all nodes for now.
135     if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
136       kernel_args+=" ${arr[2]}=${arr[3]}"
137     fi
138     done
139
140     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
141        sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
142        sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
143        sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
144 EOI
145   fi
146
147   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
148     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
149       sed -i "/neutron::agents::dhcp::interface_driver:/c\    neutron::agents::dhcp::interface_driver: neutron.agent.linux.interface.NSDriver" ${ENV_FILE}
150       sed -i "/neutron::agents::l3::interface_driver:/c\    neutron::agents::l3::interface_driver: neutron.agent.linux.interface.NSDriver" ${ENV_FILE}
151 EOI
152   fi
153
154   # Set ODL version accordingly
155   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
156     case "${deploy_options_array['odl_version']}" in
157       beryllium) odl_version=''
158               ;;
159       boron)  odl_version='boron'
160               ;;
161       carbon) odl_version='master'
162               ;;
163       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
164          exit 1
165          ;;
166     esac
167
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
169       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
170                                                --run-command "yum -y install /root/${odl_version}/*" \
171                                                -a overcloud-full.qcow2
172 EOI
173   fi
174
175
176   # check if ceph should be enabled
177   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
178     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
179   fi
180
181   #DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
182   DEPLOY_OPTIONS+=" -e network-environment.yaml"
183
184
185   # get number of nodes available in inventory
186   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
187   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
188
189   # check if HA is enabled
190   if [[ "$ha_enabled" == "True" ]]; then
191     if [ "$num_control_nodes" -lt 3 ]; then
192       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
193       exit 1
194     else
195      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
196      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
197      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
198     fi
199   else
200     if [ "$num_control_nodes" -lt 1 ]; then
201       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
202       exit 1
203     fi
204   fi
205
206   if [ "$num_compute_nodes" -le 0 ]; then
207     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
208     exit 1
209   else
210     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
211     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
212   fi
213
214   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
215
216   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
217   if [[ "$virtual" == "TRUE" ]]; then
218      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
219   fi
220
221   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
222
223   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
224
225   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
226 # Create a key for use by nova for live migration
227 echo "Creating nova SSH key for nova resize support"
228 ssh-keygen -f nova_id_rsa -b 1024 -P ""
229 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
230 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
231 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
232 mv -f opnfv-environment-new.yaml ${ENV_FILE}
233
234 source stackrc
235 set -o errexit
236 # Workaround for APEX-207 where sometimes swift proxy is down
237 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
238   sudo systemctl restart openstack-swift-proxy
239 fi
240 echo "Uploading overcloud glance images"
241 openstack overcloud image upload
242
243 echo "Configuring undercloud and discovering nodes"
244 openstack baremetal import --json instackenv.json
245
246 if [[ -z "$virtual" ]]; then
247   openstack baremetal introspection bulk start
248   if [[ -n "$root_disk_list" ]]; then
249     openstack baremetal configure boot --root-device=${root_disk_list}
250   else
251     openstack baremetal configure boot
252   fi
253 else
254   openstack baremetal configure boot
255 fi
256
257 echo "Configuring flavors"
258 for flavor in baremetal control compute; do
259   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
260   if openstack flavor list | grep \${flavor}; then
261     openstack flavor delete \${flavor}
262   fi
263   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
264   if ! openstack flavor list | grep \${flavor}; then
265     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
266   fi
267 done
268 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
269 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
270 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
271 echo "Configuring nameserver on ctlplane network"
272 dns_server_ext=''
273 for dns_server in ${dns_servers}; do
274   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
275 done
276 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
277 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
278 echo "Executing overcloud deployment, this should run for an extended period without output."
279 sleep 60 #wait for Hypervisor stats to check-in to nova
280 # save deploy command so it can be used for debugging
281 cat > deploy_command << EOF
282 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
283 EOF
284 EOI
285
286   if [ "$interactive" == "TRUE" ]; then
287     if ! prompt_user "Overcloud Deployment"; then
288       echo -e "${blue}INFO: User requests exit${reset}"
289       exit 0
290     fi
291   fi
292
293   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
294 source stackrc
295 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
296 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
297   $(typeset -f debug_stack)
298   debug_stack
299   exit 1
300 fi
301 EOI
302
303   # Configure DPDK
304   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
305     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
306 source stackrc
307 set -o errexit
308 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
309 echo "Running DPDK test app on \$node"
310 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
311 set -o errexit
312 sudo dpdk_helloworld --no-pci
313 sudo dpdk_nic_bind -s
314 EOF
315 done
316 EOI
317   fi
318
319   if [ "$debug" == 'TRUE' ]; then
320       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
321 source overcloudrc
322 echo "Keystone Endpoint List:"
323 openstack endpoint list
324 echo "Keystone Service List"
325 openstack service list
326 EOI
327   fi
328 }